module sales_forecaster

    using Epicenter

	marketsize = 25000000
	purchaseprobability = 0.05
	contactspermonth = 10
	averagemonthstorepurchase = 36
	initialsales = 50000
	forecastlength = 24
	
	installedbase = [0,0]
	remainingmarket = [0,0]
	newsales = [0,0]
	repurchases = [0,0]
	totalsales = [0,0]
	
	function forecast_sales()
    
	    global installedbase = Float64[]
	    global remainingmarket = Float64[]
	    global newsales = Float64[]
	    global repurchases = Float64[]
	    global totalsales = Float64[]
		      
	    for i in 1:forecastlength
        
	        if(i == 1)
	            push!(installedbase, initialsales)
	            push!(remainingmarket, marketsize - installedbase[i])
	        else
	            push!(installedbase, int(installedbase[i-1] + newsales[i-1]))
	            push!(remainingmarket, int(remainingmarket[i-1] - newsales[i-1]))
    		end
			
	        push!(newsales, int(installedbase[i] * contactspermonth * purchaseprobability * (remainingmarket[i] / marketsize)))
	        push!(repurchases, int(installedbase[i] / averagemonthstorepurchase))
	        push!(totalsales, newsales[i] + repurchases[i])
			
		end
        
	 end
	 
end
