library(Epicenter)

marketsize <- 25000000
purchaseprobability <- 0.05
contactspermonth <- 10
averagemonthstorepurchase <- 36
initialsales <- 50000
forecastlength <- 24

installedbase <- rep(0,24)
remainingmarket <- rep(0,24)
newsales <- rep(0,24)
repurchases <- rep(0,24)
totalsales <- rep(0,24)

forecast_sales <- function() {
	
	installedbase <<- c()
	remainingmarket <<- c()
	newsales <<- c()
	repurchases <<- c()
	totalsales <<- c()
	
    for (i in 1:forecastlength) {
        
        if(i == 1) {
            installedbase <<- c(installedbase, initialsales)
            remainingmarket <<- c(remainingmarket, marketsize - installedbase[i])
        } else {
            installedbase <<- c(installedbase, as.integer(installedbase[i-1] + newsales[i-1]))
            remainingmarket <<- c(remainingmarket, as.integer(remainingmarket[i-1] - newsales[i-1]))
    	}
			
        newsales <<- c(newsales, as.integer(installedbase[i] * contactspermonth * purchaseprobability * (remainingmarket[i] / marketsize)))
        repurchases <<- c(repurchases, as.integer(installedbase[i] / averagemonthstorepurchase))
        totalsales <<- c(totalsales, newsales[i] + repurchases[i])     
	} 
	
}


